

/* -------------------------------------------------------------------------
   A. Veneziani - Programma che esegue calcoli con oggetti rappresentanti
                  numeri complessi
				  
				  Il file contiene tre classi, ossia tre diversi modi
				  di implementare un oggetto "numero complesso" per
				  per poi effettuare su tali numeri le operazioni di 
				  somma e moltiplicazione

---------------------------------------------------------------------------- */



// classe che utilizza la classe Complessi
class UsaComplessi
{

      public static void main(String[] args) {

           // ==============  Test della prima classe Complessi ( implementazione     ====================
           // ==============  ad oggetti delle operazioni su numeri complessi)        ====================

           // Questa implementazione prevede una implementazione statica dei metodi
		   // che implementano la somma e la moltiplicazione, di modo che per usarli
		   // essi non debbano essere applicati ad un oggetto, ma alla classe stessa 
		   // (si pensi alla classe Math e alle funzioni (metodi) che contiene)

           // dichiara degli oggetti numeri complessi
           Complessi RisComplx, Complx1, Complx2;

           // istanzia due oggetti (numeri complessi) con valori scelti a piacere
           Complx1 = new Complessi(2,3);
           Complx2 = new Complessi(5,1);

           // effettua l'operazione di somma su complessi...
           RisComplx = Complessi.sommaCmplx(Complx1, Complx2);
           // stampa il risultato di questa operazione
           System.out.println("La somma dei due complessi " + Complessi.stampaCmplx(Complx1) +
                              " e " +   Complessi.stampaCmplx(Complx2) + " risulta " +
                              Complessi.stampaCmplx(RisComplx));

           // effettua l'operazione di somma su complessi...
           RisComplx = Complessi.moltCmplx(Complx1, Complx2);
           // stampa il risultato di questa operazione
           System.out.println("La moltiplicazione dei due complessi " + Complessi.stampaCmplx(Complx1) +
                              " e " +   Complessi.stampaCmplx(Complx2) + " risulta " +
                              Complessi.stampaCmplx(RisComplx));
           
           // ==============  Test della classe ComplessiBis (diversa implementazione ====================
           // ==============  ad oggetti delle operazioni su numeri complessi)        ====================
           
           // In questa classe i metodi relativi alla somma ed alla moltiplicazione non sono
		   // statici e conseguenza di ci essi devono essere applicati all'istanza di un oggetto
		   // di tipo ComplessiBis.
		   // In questo caso la specifica implementazione prevede per questi metodi che
		   // essi rendano un oggetto, contenente il risultato delle operazioni
		   // Questo nuovo ulteriore oggetto viene creato al volo nei metodi stessi
		   // il puntatore all'oggetto e l'oggetto stesso permangono oltre il tempo
		   // anche quando il metodo ha cessato le sue operazioni

           ComplessiBis Cmp1, Cmp2, CRis;
           
           // istanzia due oggetti (numeri complessi) con valori scelti a piacere
           Cmp1 = new ComplessiBis(3,2);
           Cmp2 = new ComplessiBis(1,6);
           
           CRis = Cmp1.moltCmplx(Cmp2);
           
           System.out.println("===============================================================================");
           System.out.println("La somma dei due complessi 3 + i2 e 1 + i6 risulta: " + CRis.stampaCmplx());
           
          
           // ==============  Test della classe ComplessiTris (diversa implementazione ====================
           // ==============  ad oggetti delle operazioni su numeri complessi)         ====================
           
           ComplessiTris Cmp31, Cmp32;
           
           // istanzia due oggetti (numeri complessi) con valori scelti a piacere
           Cmp31 = new ComplessiTris(3,2);
           Cmp32 = new ComplessiTris(1,6);
           
           Cmp31.moltCmplx(Cmp32);
           
           System.out.println("===============================================================================");
           System.out.println("La moltiplicazione dei due complessi 3 + i2 e 1 + i6 risulta: " + Cmp31.stampaCmplx());           

     }

}

// classe dei complessi 
class Complessi
{
     // campi reale e immaginario di un numero complesso
     private float reale, immaginaria;

     // costruttore del numero complesso
     Complessi(float r, float i)
     {
          reale = r;
          immaginaria = i;
     }

     // definisce una operazione di somma su 2 numeri complessi
     static Complessi sommaCmplx(Complessi C1, Complessi C2)
     {
         Complessi C_loc = new Complessi(0,0);

         // operazione di somma effettuata secondo le regole dei numeri complessi
         C_loc.reale = C1.reale + C2.reale;
         C_loc.immaginaria = C1.immaginaria + C2.immaginaria;

         return(C_loc);    // rende un complesso contenente il risultato del calcolo
     }

     // definisce una operazione di somma su 2 numeri complessi
    static Complessi moltCmplx(Complessi C1, Complessi C2)
     {
         Complessi C_loc = new Complessi(0,0);

         // operazione di moltiplicazione effettuata secondo le regole dei numeri complessi         
         C_loc.reale = (C1.reale * C2.reale) - (C1.immaginaria * C2.immaginaria);
         C_loc.immaginaria = (C1.reale * C2.immaginaria) + (C1.immaginaria * C2.reale);

         return(C_loc);   // rende un complesso contenente il risultato del calcolo
     }

     // stampa un numero complesso nella notazione (a + i b)
     static String stampaCmplx(Complessi C)
     {
         return(C.reale + " + i " + C.immaginaria);
     }

}


class ComplessiBis
{
      // attributi id tipo privato
      private float reale, immaginaria;
     
	 // costruttore 
     ComplessiBis(float r, float i)
     {
	      // assegna il valore dei parametri agli attributi
          reale = r;
          immaginaria = i;
     }     
     

     ComplessiBis sommaCmplx(ComplessiBis C)
     {
         float r, i;
         
          r =  this.reale + C.reale;
          i =  this.immaginaria + C.immaginaria;          
          
		  // return + allocazione di un oggetto complesso opportuno
		  // (ossia con valori pari a r ed i)
          return(new ComplessiBis(r,i));   
     }
     
     ComplessiBis moltCmplx(ComplessiBis C)
     {
         float r, i;
 
          r =  (this.reale * C.reale) - (this.immaginaria * C.immaginaria);
          i =  (this.reale * C.immaginaria) + (this.immaginaria * C.reale);    

		  // return + allocazione di un oggetto complesso opportuno
		  // (ossia con valori pari a r ed i)		  
          return(new ComplessiBis(r,i));
     }     
     
    // metodo per rendere esplicito (stampare) il contenuto di un oggetto ComplessiBis
    String stampaCmplx()
     {
        return(this.reale + " + i " + this.immaginaria);
     }     
}


class ComplessiTris
{
     // attributi id tipo privato     
     private float reale, immaginaria;
    
	 // costruttore
     ComplessiTris(float r, float i)
     {
	      // assegna il valore dei parametri agli attributi
          reale = r;
          immaginaria = i;
     }     
    
	// metodo per effettuare la somma di complessi in questa classe
	// (il metodo non rende nulla (void) perch in realt esso
	//  inserisce i risultati nell'oggetto usato per invocare 
	//  metodo stesso)
     void sommaCmplx(ComplessiTris C)
     {
         this.reale = this.reale + C.reale;
         this.immaginaria = this.immaginaria + C.immaginaria;                  
     }
     
	 // metodo per effettuare la moltiplicazione di complessi in questa classe
	// (il metodo non rende nulla (void) perch in realt esso
	//  inserisce i risultati nell'oggetto usato per invocare 
	//  metodo stesso)
     void moltCmplx(ComplessiTris C)
     {
	    // variabile di appoggio; necessaria perch il valore this.reale viene
		// di nuovo utilizzato e non  possibile quindi aggiornarlo immediatamente
		// dopo la prima istruzione di calcolo
        float reale_nuova;        

        reale_nuova = (this.reale * C.reale) - (this.immaginaria * C.immaginaria);  
        this.immaginaria = (this.reale * C.immaginaria) + (this.immaginaria * C.reale);
        
        this.reale = reale_nuova; 
     }
     
	 // metodo per rendere esplicito (stampare) il contenuto di un oggetto ComplessiTris
     String stampaCmplx()
     {
	    // recupera e rende i valori dei campi interni (attributi)
		// di questo oggetto medesimo
        return(this.reale + " + i " + this.immaginaria);
     }
         
}

